#include <ports.h>

uint8_t inb(uint16_t port) {
	unsigned char result;
	asm("in %%dx, %%al" : "=a" (result) : "d" (port));
	return result;
}

void outb(uint16_t port, uint8_t data) {
	asm("out %%al, %%dx" : : "a" (data), "d" (port));
}

uint16_t inw(uint16_t port){
	uint16_t ret;
	asm volatile ("inw %1, %0" : "=a" (ret) : "dN" (port));
	return ret;
}

void outw(uint16_t port, uint16_t data){
	asm volatile ("outw %1, %0" : : "dN" (port), "a" (data));
}
