#include <video.h>
#include <ports.h>
#include <string.h>

// start in 80x25 mode
char* vga = (char*)0xB8000;

void cls() {
	for(int i; i < 2000; i++) vga[i*2] = ' ';
	setcursor(0);
}

void setcursor(unsigned int i) {
	outb(VGA_CCTRL, 14);
	outb(VGA_CDATA, i >> 8);
	outb(VGA_CCTRL, 15);
	outb(VGA_CDATA, i & 0xff);
}

int getcursor() {
	outb(VGA_CCTRL, 14);
	uint8_t ofs = inb(VGA_CDATA) << 8;
	outb(VGA_CCTRL, 15);
	ofs += inb(VGA_CDATA);
	return ofs;
}
